Index: src/builder.cpp
===================================================================
--- src/builder.cpp	(revision b0e9c9b269a10c150b013b7fb592c9bf4771717b)
+++ src/builder.cpp	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
@@ -53,4 +53,5 @@
 
 #include <cstring>
+#include <cstdlib>
 
 #include "analysis_bonds.hpp"
@@ -864,6 +865,6 @@
 
         mol->CountAtoms(); // recount atoms
-        if (mol->AtomCount != 0) {  // if there is more than none
-          count = mol->AtomCount;  // is changed becausing of adding, thus has to be stored away beforehand
+        if (mol->getAtomCount() != 0) {  // if there is more than none
+          count = mol->getAtomCount();  // is changed becausing of adding, thus has to be stored away beforehand
           Elements = new element *[count];
           vectors = new Vector *[count];
@@ -1295,5 +1296,5 @@
   // generate some KeySets
   DoLog(0) && (Log() << Verbose(0) << "Generating KeySets." << endl);
-  KeySet TestSets[mol->AtomCount+1];
+  KeySet TestSets[mol->getAtomCount()+1];
   i=1;
   while (Walker->next != mol->end) {
@@ -1306,5 +1307,5 @@
   DoLog(0) && (Log() << Verbose(0) << "Testing insertion of already present item in KeySets." << endl);
   KeySetTestPair test;
-  test = TestSets[mol->AtomCount-1].insert(Walker->nr);
+  test = TestSets[mol->getAtomCount()-1].insert(Walker->nr);
   if (test.second) {
     DoLog(1) && (Log() << Verbose(1) << "Insertion worked?!" << endl);
@@ -1312,6 +1313,6 @@
     DoLog(1) && (Log() << Verbose(1) << "Insertion rejected: Present object is " << (*test.first) << "." << endl);
   }
-  TestSets[mol->AtomCount].insert(mol->end->previous->nr);
-  TestSets[mol->AtomCount].insert(mol->end->previous->previous->previous->nr);
+  TestSets[mol->getAtomCount()].insert(mol->end->previous->nr);
+  TestSets[mol->getAtomCount()].insert(mol->end->previous->previous->previous->nr);
 
   // constructing Graph structure
@@ -1321,10 +1322,10 @@
   // insert KeySets into Subgraphs
   DoLog(0) && (Log() << Verbose(0) << "Inserting KeySets into Subgraph class." << endl);
-  for (int j=0;j<mol->AtomCount;j++) {
+  for (int j=0;j<mol->getAtomCount();j++) {
     Subgraphs.insert(GraphPair (TestSets[j],pair<int, double>(counter++, 1.)));
   }
   DoLog(0) && (Log() << Verbose(0) << "Testing insertion of already present item in Subgraph." << endl);
   GraphTestPair test2;
-  test2 = Subgraphs.insert(GraphPair (TestSets[mol->AtomCount],pair<int, double>(counter++, 1.)));
+  test2 = Subgraphs.insert(GraphPair (TestSets[mol->getAtomCount()],pair<int, double>(counter++, 1.)));
   if (test2.second) {
     DoLog(1) && (Log() << Verbose(1) << "Insertion worked?!" << endl);
@@ -1494,5 +1495,5 @@
  */
 static int ParseCommandLineOptions(int argc, char **argv, MoleculeListClass *&molecules, periodentafel *&periode,
-                                   config& configuration, char *&ConfigFileName, set<int> &ArgcList)
+                                   config& configuration, char **ConfigFileName, set<int> &ArgcList)
 {
   Vector x,y,z,n;  // coordinates for absolute point in cell volume
@@ -1512,5 +1513,5 @@
   molecule *mol = NULL;
   string BondGraphFileName("\n");
-  strncpy(configuration.databasepath, LocalPath, MAXSTRINGSIZE-1);
+  bool DatabasePathGiven = false;
 
   if (argc > 1) { // config file specified as option
@@ -1529,28 +1530,23 @@
             break;
           case 'v':
-            ArgcList.insert(argptr-1);
-            return(1);
-            break;
-          case 'V':
+            setVerbosity(atoi(argv[argptr]));
             ArgcList.insert(argptr-1);
             ArgcList.insert(argptr);
             argptr++;
             break;
+          case 'V':
+            ArgcList.insert(argptr-1);
+            return(1);
+            break;
           case 'B':
+            ArgcList.insert(argptr-1);
+            ArgcList.insert(argptr);
+            ArgcList.insert(argptr+1);
+            ArgcList.insert(argptr+2);
+            ArgcList.insert(argptr+3);
+            ArgcList.insert(argptr+4);
+            ArgcList.insert(argptr+5);
+            argptr+=6;
             if (ExitFlag == 0) ExitFlag = 1;
-            if ((argptr+5 >= argc) || (argv[argptr][0] == '-') || (!IsValidNumber(argv[argptr])) || (!IsValidNumber(argv[argptr+1])) || (!IsValidNumber(argv[argptr+2])) || (!IsValidNumber(argv[argptr+3])) || (!IsValidNumber(argv[argptr+4])) || (!IsValidNumber(argv[argptr+5])) ) {
-              ExitFlag = 255;
-              DoeLog(0) && (eLog()<< Verbose(0) << "Not enough or invalid arguments given for bounding in box: -B <xx> <xy> <xz> <yy> <yz> <zz>" << endl);
-              performCriticalExit();
-            } else {
-              SaveFlag = true;
-              j = -1;
-              DoLog(1) && (Log() << Verbose(1) << "Centering atoms in config file within given simulation box." << endl);
-              double * const cell_size = World::getInstance().getDomain();
-              for (int i=0;i<6;i++) {
-                cell_size[i] = atof(argv[argptr+i]);
-              }
-              argptr+=6;
-            }
             break;
           case 'e':
@@ -1561,4 +1557,5 @@
               DoLog(0) && (Log() << Verbose(0) << "Using " << argv[argptr] << " as elements database." << endl);
               strncpy (configuration.databasepath, argv[argptr], MAXSTRINGSIZE-1);
+              DatabasePathGiven = true;
               argptr+=1;
             }
@@ -1574,4 +1571,15 @@
             }
             break;
+          case 'M':
+            if ((argptr >= argc) || (argv[argptr][0] == '-')) {
+              ExitFlag = 255;
+              DoeLog(0) && (eLog()<< Verbose(0) << "Not enough or invalid arguments given for setting MPQC basis: -M <basis name>" << endl);
+              performCriticalExit();
+            } else {
+              configuration.basis = argv[argptr];
+              DoLog(1) && (Log() << Verbose(1) << "Setting MPQC basis to " << configuration.basis << "." << endl);
+              argptr+=1;
+            }
+            break;
           case 'n':
             DoLog(0) && (Log() << Verbose(0) << "I won't parse trajectories." << endl);
@@ -1581,5 +1589,5 @@
             {
               World::getInstance().setDefaultName(argv[argptr]);
-              DoLog(0) && (Log() << Verbose(0) << "Default name of new molecules set to " << *World::getInstance().getDefaultName() << "." << endl);
+              DoLog(0) && (Log() << Verbose(0) << "Default name of new molecules set to " << World::getInstance().getDefaultName() << "." << endl);
             }
             break;
@@ -1593,11 +1601,12 @@
 
     // 3a. Parse the element database
-    if (periode->LoadPeriodentafel(configuration.databasepath)) {
-      DoLog(0) && (Log() << Verbose(0) << "Element list loaded successfully." << endl);
-      //periode->Output();
-    } else {
-      DoLog(0) && (Log() << Verbose(0) << "Element list loading failed." << endl);
-      return 1;
-    }
+    if (DatabasePathGiven)
+      if (periode->LoadPeriodentafel(configuration.databasepath)) {
+        DoLog(0) && (Log() << Verbose(0) << "Element list loaded successfully." << endl);
+        //periode->Output();
+      } else {
+        DoLog(0) && (Log() << Verbose(0) << "Element list loading failed." << endl);
+        return 1;
+      }
     // 3b. Find config file name and parse if possible, also BondGraphFileName
     if (argv[1][0] != '-') {
@@ -1613,5 +1622,5 @@
         } else {
           DoLog(0) && (Log() << Verbose(0) << "Empty configuration file." << endl);
-          ConfigFileName = argv[1];
+          strcpy(*ConfigFileName, argv[1]);
           configPresent = empty;
           output.close();
@@ -1619,15 +1628,15 @@
       } else {
         test.close();
-        ConfigFileName = argv[1];
+        strcpy(*ConfigFileName, argv[1]);
         DoLog(1) && (Log() << Verbose(1) << "Specified config file found, parsing ... ");
-        switch (configuration.TestSyntax(ConfigFileName, periode)) {
+        switch (configuration.TestSyntax(*ConfigFileName, periode)) {
           case 1:
             DoLog(0) && (Log() << Verbose(0) << "new syntax." << endl);
-            configuration.Load(ConfigFileName, BondGraphFileName, periode, molecules);
+            configuration.Load(*ConfigFileName, BondGraphFileName, periode, molecules);
             configPresent = present;
             break;
           case 0:
             DoLog(0) && (Log() << Verbose(0) << "old syntax." << endl);
-            configuration.LoadOld(ConfigFileName, BondGraphFileName, periode, molecules);
+            configuration.LoadOld(*ConfigFileName, BondGraphFileName, periode, molecules);
             configPresent = present;
             break;
@@ -1650,6 +1659,6 @@
        mol = World::getInstance().createMolecule();
        mol->ActiveFlag = true;
-       if (ConfigFileName != NULL)
-         mol->SetNameFromFilename(ConfigFileName);
+       if (*ConfigFileName != NULL)
+         mol->SetNameFromFilename(*ConfigFileName);
        molecules->insert(mol);
      }
@@ -1705,5 +1714,5 @@
                 if (first->type != NULL) {
                   mol->AddAtom(first);  // add to molecule
-                  if ((configPresent == empty) && (mol->AtomCount != 0))
+                  if ((configPresent == empty) && (mol->getAtomCount() != 0))
                     configPresent = present;
                 } else
@@ -1718,15 +1727,4 @@
         if (configPresent == present) {
           switch(argv[argptr-1][1]) {
-            case 'M':
-              if ((argptr >= argc) || (argv[argptr][0] == '-')) {
-                ExitFlag = 255;
-                DoeLog(0) && (eLog()<< Verbose(0) << "Not enough or invalid arguments given for setting MPQC basis: -B <basis name>" << endl);
-                performCriticalExit();
-              } else {
-                configuration.basis = argv[argptr];
-                DoLog(1) && (Log() << Verbose(1) << "Setting MPQC basis to " << configuration.basis << "." << endl);
-                argptr+=1;
-              }
-              break;
             case 'D':
               if (ExitFlag == 0) ExitFlag = 1;
@@ -1734,5 +1732,5 @@
                 DoLog(1) && (Log() << Verbose(1) << "Depth-First-Search Analysis." << endl);
                 MoleculeLeafClass *Subgraphs = NULL;      // list of subgraphs from DFS analysis
-                int *MinimumRingSize = new int[mol->AtomCount];
+                int *MinimumRingSize = new int[mol->getAtomCount()];
                 atom ***ListOfLocalAtoms = NULL;
                 class StackClass<bond *> *BackEdgeStack = NULL;
@@ -1754,6 +1752,6 @@
                   delete(Subgraphs);
                   for (int i=0;i<FragmentCounter;i++)
-                    Free(&ListOfLocalAtoms[i]);
-                  Free(&ListOfLocalAtoms);
+                    delete[](ListOfLocalAtoms[i]);
+                  delete[](ListOfLocalAtoms);
                 }
                 delete(BackEdgeStack);
@@ -1795,5 +1793,5 @@
                         if ((argptr+6 >= argc) || (!IsValidNumber(argv[argptr+1])) || (!IsValidNumber(argv[argptr+5])) || (!IsValidNumber(argv[argptr+6])) || (!IsValidNumber(argv[argptr+2])) || (argv[argptr+1][0] == '-') || (argv[argptr+2][0] == '-') || (argv[argptr+3][0] == '-') || (argv[argptr+4][0] == '-')) {
                           ExitFlag = 255;
-                          DoeLog(0) && (eLog()<< Verbose(0) << "Not enough or invalid arguments given for pair correlation analysis: -C E <Z1> <Z2> <output> <bin output>" << endl);
+                          DoeLog(0) && (eLog()<< Verbose(0) << "Not enough or invalid arguments given for pair correlation analysis: -C E <Z1> <Z2> <output> <bin output> <binstart> <binend>" << endl);
                           performCriticalExit();
                         } else {
@@ -1810,5 +1808,5 @@
                           else
                             correlationmap = PairCorrelation(molecules, elemental, elemental2);
-                          //OutputCorrelationToSurface(&output, correlationmap);
+                          OutputPairCorrelation(&output, correlationmap);
                           BinPairMap *binmap = BinData( correlationmap, 0.5, BinStart, BinEnd );
                           OutputCorrelation ( &binoutput, binmap );
@@ -1826,5 +1824,5 @@
                         if ((argptr+8 >= argc) || (!IsValidNumber(argv[argptr+1])) ||  (!IsValidNumber(argv[argptr+2])) || (!IsValidNumber(argv[argptr+3])) || (!IsValidNumber(argv[argptr+4])) || (!IsValidNumber(argv[argptr+7])) || (!IsValidNumber(argv[argptr+8])) || (argv[argptr+1][0] == '-') || (argv[argptr+2][0] == '-') || (argv[argptr+3][0] == '-') || (argv[argptr+4][0] == '-') || (argv[argptr+5][0] == '-') || (argv[argptr+6][0] == '-')) {
                           ExitFlag = 255;
-                          DoeLog(0) && (eLog()<< Verbose(0) << "Not enough or invalid arguments given for pair correlation analysis: -C P <Z1> <x> <y> <z> <output> <bin output>" << endl);
+                          DoeLog(0) && (eLog()<< Verbose(0) << "Not enough or invalid arguments given for pair correlation analysis: -C P <Z1> <x> <y> <z> <output> <bin output> <binstart> <binend>" << endl);
                           performCriticalExit();
                         } else {
@@ -1841,5 +1839,5 @@
                           else
                             correlationmap = CorrelationToPoint(molecules, elemental, Point);
-                          //OutputCorrelationToSurface(&output, correlationmap);
+                          OutputCorrelationToPoint(&output, correlationmap);
                           BinPairMap *binmap = BinData( correlationmap, 0.5, BinStart, BinEnd );
                           OutputCorrelation ( &binoutput, binmap );
@@ -1882,10 +1880,10 @@
                           int counter  = 0;
                           for (MoleculeList::iterator BigFinder = molecules->ListOfMolecules.begin(); BigFinder != molecules->ListOfMolecules.end(); BigFinder++) {
-                            if ((Boundary == NULL) || (Boundary->AtomCount < (*BigFinder)->AtomCount)) {
+                            if ((Boundary == NULL) || (Boundary->getAtomCount() < (*BigFinder)->getAtomCount())) {
                               Boundary = *BigFinder;
                             }
                             counter++;
                           }
-                          bool *Actives = Malloc<bool>(counter, "ParseCommandLineOptions() - case C -- *Actives");
+                          bool *Actives = new bool[counter];
                           counter = 0;
                           for (MoleculeList::iterator BigFinder = molecules->ListOfMolecules.begin(); BigFinder != molecules->ListOfMolecules.end(); BigFinder++) {
@@ -1913,7 +1911,8 @@
                           output.close();
                           binoutput.close();
+                          counter = 0;
                           for (MoleculeList::iterator BigFinder = molecules->ListOfMolecules.begin(); BigFinder != molecules->ListOfMolecules.end(); BigFinder++)
                             (*BigFinder)->ActiveFlag = Actives[counter++];
-                          Free(&Actives);
+                          delete[](Actives);
                           delete(LCList);
                           delete(TesselStruct);
@@ -1941,4 +1940,5 @@
                 performCriticalExit();
               } else {
+                mol->getAtomCount();
                 SaveFlag = true;
                 DoLog(1) && (Log() << Verbose(1) << "Changing atom " << argv[argptr] << " to element " << argv[argptr+1] << "." << endl);
@@ -1950,52 +1950,19 @@
             case 'F':
               if (ExitFlag == 0) ExitFlag = 1;
-              MaxDistance = -1;
-              if (argv[argptr-1][2] == 'F') { // option is -FF?
-                // fetch first argument as max distance to surface
-                MaxDistance = atof(argv[argptr++]);
-                DoLog(0) && (Log() << Verbose(0) << "Filling with maximum layer distance of " << MaxDistance << "." << endl);
-              }
-              if ((argptr+7 >=argc) || (argv[argptr][0] == '-') || (!IsValidNumber(argv[argptr+1])) || (!IsValidNumber(argv[argptr+2])) || (!IsValidNumber(argv[argptr+3])) || (!IsValidNumber(argv[argptr+4])) || (!IsValidNumber(argv[argptr+5])) || (!IsValidNumber(argv[argptr+6])) || (!IsValidNumber(argv[argptr+7]))) {
-                ExitFlag = 255;
-                DoeLog(0) && (eLog()<< Verbose(0) << "Not enough or invalid arguments given for filling box with water: -F <xyz of filler> <dist_x> <dist_y> <dist_z> <boundary> <randatom> <randmol> <DoRotate>" << endl);
-                performCriticalExit();
-              } else {
-                SaveFlag = true;
-                DoLog(1) && (Log() << Verbose(1) << "Filling Box with water molecules." << endl);
-                // construct water molecule
-                molecule *filler = World::getInstance().createMolecule();
-                if (!filler->AddXYZFile(argv[argptr])) {
-                  DoeLog(0) && (eLog()<< Verbose(0) << "Could not parse filler molecule from " << argv[argptr] << "." << endl);
-                }
-                filler->SetNameFromFilename(argv[argptr]);
-                configuration.BG->ConstructBondGraph(filler);
-                molecule *Filling = NULL;
-                atom *second = NULL, *third = NULL;
-                first = World::getInstance().createAtom();
-                first->type = periode->FindElement(1);
-                first->x = Vector(0.441, -0.143, 0.);
-                filler->AddAtom(first);
-                second = World::getInstance().createAtom();
-                second->type = periode->FindElement(1);
-                second->x = Vector(-0.464, 1.137, 0.0);
-                filler->AddAtom(second);
-                third = World::getInstance().createAtom();
-                third->type = periode->FindElement(8);
-                third->x = Vector(-0.464, 0.177, 0.);
-                filler->AddAtom(third);
-                filler->AddBond(first, third, 1);
-                filler->AddBond(second, third, 1);
-                // call routine
-                double distance[NDIM];
-                for (int i=0;i<NDIM;i++)
-                  distance[i] = atof(argv[argptr+i+1]);
-                Filling = FillBoxWithMolecule(molecules, filler, configuration, MaxDistance, distance, atof(argv[argptr+4]), atof(argv[argptr+5]), atof(argv[argptr+6]), atoi(argv[argptr+7]));
-                if (Filling != NULL) {
-                  Filling->ActiveFlag = false;
-                  molecules->insert(Filling);
-                }
-                World::getInstance().destroyMolecule(filler);
-                argptr+=6;
-              }
+              ArgcList.insert(argptr-1);
+              ArgcList.insert(argptr);
+              ArgcList.insert(argptr+1);
+              ArgcList.insert(argptr+2);
+              ArgcList.insert(argptr+3);
+              ArgcList.insert(argptr+4);
+              ArgcList.insert(argptr+5);
+              ArgcList.insert(argptr+6);
+              ArgcList.insert(argptr+7);
+              ArgcList.insert(argptr+8);
+              ArgcList.insert(argptr+9);
+              ArgcList.insert(argptr+10);
+              ArgcList.insert(argptr+11);
+              ArgcList.insert(argptr+12);
+              argptr+=13;
               break;
             case 'A':
@@ -2007,7 +1974,7 @@
               } else {
                 DoLog(0) && (Log() << Verbose(0) << "Parsing bonds from " << argv[argptr] << "." << endl);
-                ifstream *input = new ifstream(argv[argptr]);
-                mol->CreateAdjacencyListFromDbondFile(input);
-                input->close();
+                ifstream input(argv[argptr]);
+                mol->CreateAdjacencyListFromDbondFile(&input);
+                input.close();
                 argptr+=1;
               }
@@ -2059,11 +2026,10 @@
                 int counter  = 0;
                 for (MoleculeList::iterator BigFinder = molecules->ListOfMolecules.begin(); BigFinder != molecules->ListOfMolecules.end(); BigFinder++) {
-                  (*BigFinder)->CountAtoms();
-                  if ((Boundary == NULL) || (Boundary->AtomCount < (*BigFinder)->AtomCount)) {
+                  if ((Boundary == NULL) || (Boundary->getAtomCount() < (*BigFinder)->getAtomCount())) {
                     Boundary = *BigFinder;
                   }
                   counter++;
                 }
-                DoLog(1) && (Log() << Verbose(1) << "Biggest molecule has " << Boundary->AtomCount << " atoms." << endl);
+                DoLog(1) && (Log() << Verbose(1) << "Biggest molecule has " << Boundary->getAtomCount() << " atoms." << endl);
                 start = clock();
                 LCList = new LinkedCell(Boundary, atof(argv[argptr])*2.);
@@ -2100,5 +2066,5 @@
               if ((argptr >= argc) || (argv[argptr][0] == '-')) {
                 ExitFlag = 255;
-                DoeLog(0) && (eLog()<< Verbose(0) << "Not enough or invalid arguments given for storing tempature: -L <step0> <step1> <prefix> <identity mapping?>" << endl);
+                DoeLog(0) && (eLog()<< Verbose(0) << "Not enough or invalid arguments given for linear interpolation: -L <step0> <step1> <prefix> <identity mapping?>" << endl);
                 performCriticalExit();
               } else {
@@ -2132,26 +2098,25 @@
             case 'R':
               if (ExitFlag == 0) ExitFlag = 1;
-              if ((argptr+1 >= argc) || (argv[argptr][0] == '-') || (!IsValidNumber(argv[argptr])) || (!IsValidNumber(argv[argptr+1])))  {
+              if ((argptr+3 >= argc) || (argv[argptr][0] == '-') || (!IsValidNumber(argv[argptr])) || (!IsValidNumber(argv[argptr+1])) || (!IsValidNumber(argv[argptr+2])) || (!IsValidNumber(argv[argptr+3])))  {
                 ExitFlag = 255;
-                DoeLog(0) && (eLog()<< Verbose(0) << "Not enough or invalid arguments given for removing atoms: -R <id> <distance>" << endl);
+                DoeLog(0) && (eLog()<< Verbose(0) << "Not enough or invalid arguments given for removing atoms: -R <x> <y> <z> <distance>" << endl);
                 performCriticalExit();
               } else {
                 SaveFlag = true;
-                DoLog(1) && (Log() << Verbose(1) << "Removing atoms around " << argv[argptr] << " with radius " << argv[argptr+1] << "." << endl);
-                double tmp1 = atof(argv[argptr+1]);
-                atom *third = mol->FindAtom(atoi(argv[argptr]));
-                atom *first = mol->start;
-                if ((third != NULL) && (first != mol->end)) {
-                  atom *second = first->next;
-                  while(second != mol->end) {
-                    first = second;
-                    second = first->next;
-                    if (first->x.DistanceSquared(third->x) > tmp1*tmp1) // distance to first above radius ...
-                      mol->RemoveAtom(first);
+                const double radius = atof(argv[argptr+3]);
+                Vector point(atof(argv[argptr]),atof(argv[argptr+1]),atof(argv[argptr+2]));
+                DoLog(1) && (Log() << Verbose(1) << "Removing atoms around " << point << " with radius " << radius << "." << endl);
+                atom *Walker = NULL;
+                molecule::iterator advancer = mol->begin();
+                for(molecule::iterator iter = advancer; advancer != mol->end();) {
+                  iter = advancer++;
+                  if ((*iter)->x.DistanceSquared(point) > radius*radius){ // distance to first above radius ...
+                    Walker = (*iter);
+                    DoLog(1) && (Log() << Verbose(1) << "Removing atom " << *Walker << "." << endl);
+                    mol->RemoveAtom(*(iter));
+                    World::getInstance().destroyAtom(Walker);
                   }
-                } else {
-                  DoeLog(1) && (eLog()<< Verbose(1) << "Removal failed due to missing atoms on molecule or wrong id." << endl);
                 }
-                argptr+=2;
+                argptr+=4;
               }
               break;
@@ -2190,24 +2155,13 @@
             case 's':
               if (ExitFlag == 0) ExitFlag = 1;
-              if ((argptr >= argc) || (!IsValidNumber(argv[argptr])) || (!IsValidNumber(argv[argptr+1])) || (!IsValidNumber(argv[argptr+2])) ) {
+              if ((argptr+2 >= argc) || (!IsValidNumber(argv[argptr])) || (!IsValidNumber(argv[argptr+1])) || (!IsValidNumber(argv[argptr+2])) ) {
                 ExitFlag = 255;
                 DoeLog(0) && (eLog()<< Verbose(0) << "Not enough or invalid arguments given for scaling: -s <factor_x> [factor_y] [factor_z]" << endl);
                 performCriticalExit();
               } else {
-                SaveFlag = true;
-                j = -1;
-                DoLog(1) && (Log() << Verbose(1) << "Scaling all ion positions by factor." << endl);
-                factor = new double[NDIM];
-                factor[0] = atof(argv[argptr]);
-                factor[1] = atof(argv[argptr+1]);
-                factor[2] = atof(argv[argptr+2]);
-                mol->Scale((const double ** const)&factor);
-                double * const cell_size = World::getInstance().getDomain();
-                for (int i=0;i<NDIM;i++) {
-                  j += i+1;
-                  x[i] = atof(argv[NDIM+i]);
-                  cell_size[j]*=factor[i];
-                }
-                delete[](factor);
+                ArgcList.insert(argptr-1);
+                ArgcList.insert(argptr);
+                ArgcList.insert(argptr+1);
+                ArgcList.insert(argptr+2);
                 argptr+=3;
               }
@@ -2220,13 +2174,11 @@
                 performCriticalExit();
               } else {
-                SaveFlag = true;
-                j = -1;
-                DoLog(1) && (Log() << Verbose(1) << "Centering atoms in config file within given simulation box." << endl);
-                double * const cell_size = World::getInstance().getDomain();
-                for (int i=0;i<6;i++) {
-                  cell_size[i] = atof(argv[argptr+i]);
-                }
-                // center
-                mol->CenterInBox();
+                ArgcList.insert(argptr-1);
+                ArgcList.insert(argptr);
+                ArgcList.insert(argptr+1);
+                ArgcList.insert(argptr+2);
+                ArgcList.insert(argptr+3);
+                ArgcList.insert(argptr+4);
+                ArgcList.insert(argptr+5);
                 argptr+=6;
               }
@@ -2239,13 +2191,11 @@
                 performCriticalExit();
               } else {
-                SaveFlag = true;
-                j = -1;
-                DoLog(1) && (Log() << Verbose(1) << "Centering atoms in config file within given simulation box." << endl);
-                double * const cell_size = World::getInstance().getDomain();
-                for (int i=0;i<6;i++) {
-                  cell_size[i] = atof(argv[argptr+i]);
-                }
-                // center
-                mol->BoundInBox();
+                ArgcList.insert(argptr-1);
+                ArgcList.insert(argptr);
+                ArgcList.insert(argptr+1);
+                ArgcList.insert(argptr+2);
+                ArgcList.insert(argptr+3);
+                ArgcList.insert(argptr+4);
+                ArgcList.insert(argptr+5);
                 argptr+=6;
               }
@@ -2258,20 +2208,8 @@
                 performCriticalExit();
               } else {
-                SaveFlag = true;
-                j = -1;
-                DoLog(1) && (Log() << Verbose(1) << "Centering atoms in config file within given additional boundary." << endl);
-                // make every coordinate positive
-                mol->CenterEdge(&x);
-                // update Box of atoms by boundary
-                mol->SetBoxDimension(&x);
-                // translate each coordinate by boundary
-                double * const cell_size = World::getInstance().getDomain();
-                j=-1;
-                for (int i=0;i<NDIM;i++) {
-                  j += i+1;
-                  x[i] = atof(argv[argptr+i]);
-                  cell_size[j] += x[i]*2.;
-                }
-                mol->Translate((const Vector *)&x);
+                ArgcList.insert(argptr-1);
+                ArgcList.insert(argptr);
+                ArgcList.insert(argptr+1);
+                ArgcList.insert(argptr+2);
                 argptr+=3;
               }
@@ -2279,9 +2217,5 @@
             case 'O':
               if (ExitFlag == 0) ExitFlag = 1;
-              SaveFlag = true;
-              DoLog(1) && (Log() << Verbose(1) << "Centering atoms on edge and setting box dimensions." << endl);
-              x.Zero();
-              mol->CenterEdge(&x);
-              mol->SetBoxDimension(&x);
+              ArgcList.insert(argptr-1);
               argptr+=0;
               break;
@@ -2293,4 +2227,5 @@
                 performCriticalExit();
               } else {
+                mol->getAtomCount();
                 SaveFlag = true;
                 DoLog(1) && (Log() << Verbose(1) << "Removing atom " << argv[argptr] << "." << endl);
@@ -2312,5 +2247,5 @@
                 mol->CreateAdjacencyList(atof(argv[argptr]), configuration.GetIsAngstroem(), &BondGraph::CovalentMinMaxDistance, NULL);
                 DoLog(0) && (Log() << Verbose(0) << "Fragmenting molecule with current connection matrix ..." << endl);
-                if (mol->first->next != mol->last) {
+                if (mol->hasBondStructure()) {
                   ExitFlag = mol->FragmentMolecule(atoi(argv[argptr+1]), &configuration);
                 }
